# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 url: pulumi.Input[builtins.str],
                 insecure: Optional[pulumi.Input[builtins.bool]] = None,
                 password: Optional[pulumi.Input[builtins.str]] = None,
                 retry_max_time: Optional[pulumi.Input[builtins.str]] = None,
                 retry_mode: Optional[pulumi.Input[builtins.str]] = None,
                 token: Optional[pulumi.Input[builtins.str]] = None,
                 username: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[builtins.str] url: Hostname of the xoa router. Can be set via the XOA_URL environment variable.
        :param pulumi.Input[builtins.bool] insecure: Whether SSL should be verified or not. Can be set via the XOA_INSECURE environment variable.
        :param pulumi.Input[builtins.str] password: Password for xoa api. Can be set via the XOA_PASSWORD environment variable.
        :param pulumi.Input[builtins.str] retry_max_time: If `retry_mode` is set, this specifies the duration for which the backoff method will continue retries. Can be set via
               the `XOA_RETRY_MAX_TIME` environment variable
        :param pulumi.Input[builtins.str] retry_mode: Specifies if retries should be attempted for requests that require eventual . Can be set via the XOA_RETRY_MODE
               environment variable.
        :param pulumi.Input[builtins.str] token: Password for xoa api. Can be set via the XOA_TOKEN environment variable.
        :param pulumi.Input[builtins.str] username: User account for xoa api. Can be set via the XOA_USER environment variable.
        """
        pulumi.set(__self__, "url", url)
        if insecure is not None:
            pulumi.set(__self__, "insecure", insecure)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if retry_max_time is not None:
            pulumi.set(__self__, "retry_max_time", retry_max_time)
        if retry_mode is not None:
            pulumi.set(__self__, "retry_mode", retry_mode)
        if token is not None:
            pulumi.set(__self__, "token", token)
        if username is not None:
            pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter
    def url(self) -> pulumi.Input[builtins.str]:
        """
        Hostname of the xoa router. Can be set via the XOA_URL environment variable.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "url", value)

    @property
    @pulumi.getter
    def insecure(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether SSL should be verified or not. Can be set via the XOA_INSECURE environment variable.
        """
        return pulumi.get(self, "insecure")

    @insecure.setter
    def insecure(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "insecure", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Password for xoa api. Can be set via the XOA_PASSWORD environment variable.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="retryMaxTime")
    def retry_max_time(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        If `retry_mode` is set, this specifies the duration for which the backoff method will continue retries. Can be set via
        the `XOA_RETRY_MAX_TIME` environment variable
        """
        return pulumi.get(self, "retry_max_time")

    @retry_max_time.setter
    def retry_max_time(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "retry_max_time", value)

    @property
    @pulumi.getter(name="retryMode")
    def retry_mode(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Specifies if retries should be attempted for requests that require eventual . Can be set via the XOA_RETRY_MODE
        environment variable.
        """
        return pulumi.get(self, "retry_mode")

    @retry_mode.setter
    def retry_mode(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "retry_mode", value)

    @property
    @pulumi.getter
    def token(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Password for xoa api. Can be set via the XOA_TOKEN environment variable.
        """
        return pulumi.get(self, "token")

    @token.setter
    def token(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "token", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        User account for xoa api. Can be set via the XOA_USER environment variable.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "username", value)


@pulumi.type_token("pulumi:providers:xenorchestra")
class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 insecure: Optional[pulumi.Input[builtins.bool]] = None,
                 password: Optional[pulumi.Input[builtins.str]] = None,
                 retry_max_time: Optional[pulumi.Input[builtins.str]] = None,
                 retry_mode: Optional[pulumi.Input[builtins.str]] = None,
                 token: Optional[pulumi.Input[builtins.str]] = None,
                 url: Optional[pulumi.Input[builtins.str]] = None,
                 username: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        The provider type for the xenorchestra package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] insecure: Whether SSL should be verified or not. Can be set via the XOA_INSECURE environment variable.
        :param pulumi.Input[builtins.str] password: Password for xoa api. Can be set via the XOA_PASSWORD environment variable.
        :param pulumi.Input[builtins.str] retry_max_time: If `retry_mode` is set, this specifies the duration for which the backoff method will continue retries. Can be set via
               the `XOA_RETRY_MAX_TIME` environment variable
        :param pulumi.Input[builtins.str] retry_mode: Specifies if retries should be attempted for requests that require eventual . Can be set via the XOA_RETRY_MODE
               environment variable.
        :param pulumi.Input[builtins.str] token: Password for xoa api. Can be set via the XOA_TOKEN environment variable.
        :param pulumi.Input[builtins.str] url: Hostname of the xoa router. Can be set via the XOA_URL environment variable.
        :param pulumi.Input[builtins.str] username: User account for xoa api. Can be set via the XOA_USER environment variable.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ProviderArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the xenorchestra package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 insecure: Optional[pulumi.Input[builtins.bool]] = None,
                 password: Optional[pulumi.Input[builtins.str]] = None,
                 retry_max_time: Optional[pulumi.Input[builtins.str]] = None,
                 retry_mode: Optional[pulumi.Input[builtins.str]] = None,
                 token: Optional[pulumi.Input[builtins.str]] = None,
                 url: Optional[pulumi.Input[builtins.str]] = None,
                 username: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            __props__.__dict__["insecure"] = pulumi.Output.from_input(insecure).apply(pulumi.runtime.to_json) if insecure is not None else None
            __props__.__dict__["password"] = password
            __props__.__dict__["retry_max_time"] = retry_max_time
            __props__.__dict__["retry_mode"] = retry_mode
            __props__.__dict__["token"] = token
            if url is None and not opts.urn:
                raise TypeError("Missing required property 'url'")
            __props__.__dict__["url"] = url
            __props__.__dict__["username"] = username
        super(Provider, __self__).__init__(
            'xenorchestra',
            resource_name,
            __props__,
            opts)

    @property
    @pulumi.getter
    def password(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Password for xoa api. Can be set via the XOA_PASSWORD environment variable.
        """
        return pulumi.get(self, "password")

    @property
    @pulumi.getter(name="retryMaxTime")
    def retry_max_time(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        If `retry_mode` is set, this specifies the duration for which the backoff method will continue retries. Can be set via
        the `XOA_RETRY_MAX_TIME` environment variable
        """
        return pulumi.get(self, "retry_max_time")

    @property
    @pulumi.getter(name="retryMode")
    def retry_mode(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Specifies if retries should be attempted for requests that require eventual . Can be set via the XOA_RETRY_MODE
        environment variable.
        """
        return pulumi.get(self, "retry_mode")

    @property
    @pulumi.getter
    def token(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Password for xoa api. Can be set via the XOA_TOKEN environment variable.
        """
        return pulumi.get(self, "token")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[builtins.str]:
        """
        Hostname of the xoa router. Can be set via the XOA_URL environment variable.
        """
        return pulumi.get(self, "url")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        User account for xoa api. Can be set via the XOA_USER environment variable.
        """
        return pulumi.get(self, "username")

    @pulumi.output_type
    class TerraformConfigResult:
        def __init__(__self__, result=None):
            if result and not isinstance(result, dict):
                raise TypeError("Expected argument 'result' to be a dict")
            pulumi.set(__self__, "result", result)

        @property
        @pulumi.getter
        def result(self) -> Mapping[str, Any]:
            return pulumi.get(self, "result")

    def terraform_config(__self__) -> pulumi.Output['Provider.TerraformConfigResult']:
        """
        This function returns a Terraform config object with terraform-namecased keys,to be used with the Terraform Module Provider.
        """
        __args__ = dict()
        __args__['__self__'] = __self__
        return pulumi.runtime.call('pulumi:providers:xenorchestra/terraformConfig', __args__, res=__self__, typ=Provider.TerraformConfigResult)

